package com.V10lator.TimeEvent;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import org.bukkit.block.Block;
import org.bukkit.Material;
import org.bukkit.Server;

public class Init
{
  public final File saveFile;
  private final Server server;
  public String saveRAM;
  private final TimeEvent plugin;
  
  public Init(TimeEvent plugin, Server server, String name)
  {
	this.server = server;
	this.saveFile = new File("plugins/V10lator/"+name+".sav");
	this.saveRAM = "";
	this.plugin = plugin;
  }
  
  public int initialize(short step)
  {
	if(step == 0)
	{
	  //create|check Plugin folder
      File pluginDir = new File("plugins/V10lator");

      if(!pluginDir.exists())
      {
         if(!pluginDir.mkdir())
           return -2;
      }
      
    //create|check save file
      if(!saveFile.exists())
      try
      {
    	saveFile.createNewFile();
      }
      catch (IOException e)
      {
    	return -3;
      }
	}
	else if(step == 1)
	{
	  int count = 0;
	  try {
		BufferedReader reader = new BufferedReader(new FileReader(saveFile));
		Block block = null;
		EventStone sign = null;
		String saveRAM = "";
		
		String[] result = null;
		String out = null;

		//read Data
		while(reader.ready())
		{
		  out = reader.readLine();
		  saveRAM = saveRAM + out + "\n";
		  result = out.split(",");
		  block = this.server.getWorld(result[0]).getBlockAt(Integer.parseInt (result[1]), Integer.parseInt (result[2]), Integer.parseInt (result[3]));
		  block.setTypeIdAndData(Material.SIGN_POST.getId(), Byte.parseByte(result[5]), true);
		  sign = new EventStone(block);
		  sign.setTime(result[4]);
		  this.plugin.addEventStone(block, sign);
		  count++;
		}
		this.saveRAM = saveRAM;
	  }
      catch (FileNotFoundException e)
	  {
	  }
	  catch (IOException e)
	  {
	  }
	  return count;
	}
	else
	  return -1;
	return 0;
  }
}
