package com.V10lator.TimeEvent;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Collection;

public class SaveThread extends Thread
{
  private TimeEvent plugin;
  public SaveThread(final TimeEvent plugin)
  {
    this.plugin = plugin;
  }
  
  public void run()
  {
    int ret = save();
    if(ret < 0)
    {
      if(ret == -2)
        this.plugin.info2log("No new save data.");
      else
    	this.plugin.info2log("Can't save (" + ret + ")");
    }
	else
	  this.plugin.info2log(ret + " Events saved");
  }
  
  public short save()
  {
	//Write file to ram
	Collection<EventStone> eventStone = plugin.getValues();
    String out = new String();
    short c = 0;
	for(EventStone stone: eventStone)
	{
	  out = out + 
		    stone.getWorld() + "," + 
		    stone.getX() + "," +
		    stone.getY() + "," +
			stone.getZ() + "," +
			stone.getTime() + "," +
		    stone.getOrig() + "\n";
	  c++;
	}
	if(plugin.Init.saveRAM.equals(out))
	  return -2;
	
	try
	{
	  FileWriter writer = new FileWriter(plugin.Init.saveFile);
	  writer.write(out);
	  writer.close();
	}
	catch (IOException e)
	{
	  return -1;
	}
	return c;
  }
}

