package com.V10lator.TimeEvent;

import java.util.Collection;
import java.util.HashMap;
import java.util.logging.Logger;
import org.bukkit.plugin.PluginDescriptionFile;
import org.bukkit.plugin.PluginManager;
import org.bukkit.plugin.java.JavaPlugin;
import org.bukkit.Server;
import org.bukkit.block.Block;
import org.bukkit.event.Event;

import com.V10lator.lib24time.l24t;

public class TimeEvent extends JavaPlugin
{
  private Logger log = Logger.getLogger("Mineraft");
  private final TimeEventBlockListener blockListener = new TimeEventBlockListener(this);
  public final l24t l24t = new l24t();
  public Init Init;
  
  public int pid[] = {-1,-1};
  public String name = null;
  private final HashMap<Block, EventStone> eventStone = new HashMap<Block, EventStone>();
  
  public void onEnable()
  {
	int saveIntervall = 15;
	
	Server server = getServer();
	PluginManager pm = server.getPluginManager();
	
	int major = l24t.getMajor();
	int minor = l24t.getMinor();
	if(minor < 3)
	{
	  info2log("ERROR: lib24time >= 0.3 needed (" + major + "." + minor + " found)");
	  pm.disablePlugin(this);
	  return;
	}
	
	pm.registerEvent(Event.Type.SIGN_CHANGE, blockListener, Event.Priority.Normal, this);
	pm.registerEvent(Event.Type.BLOCK_BREAK, blockListener, Event.Priority.Normal, this);
	pm.registerEvent(Event.Type.BLOCK_PHYSICS, blockListener, Event.Priority.Normal, this);
	
	PluginDescriptionFile pdfFile = this.getDescription();
    this.name = pdfFile.getName();
    
    this.Init = new Init(this, getServer(), this.name);
    int ret = this.Init.initialize((short)0);
    if(ret < 0)
    {
      this.info2log("Can't load save file (Step 1, " + ret + ")");
      pm.disablePlugin(this);
	  return;
    }
	ret = this.Init.initialize((short)1);
	if(ret < 0)
	{
	  this.info2log("Can't load save file (Step 2, " + ret + ")");
	  pm.disablePlugin(this);
	  return;
	}
	this.info2log(ret + " Events loaded");
	
	this.pid[0] = this.getServer().getScheduler().scheduleSyncRepeatingTask(this, new EventThread(this), 0, 4);
	this.pid[1] = this.getServer().getScheduler().scheduleSyncRepeatingTask(this, new SaveThread(this), 60 * saveIntervall * 10, 60 * saveIntervall * 10);
    
    this.info2log("v" + pdfFile.getVersion() + " enabled");
  }
  
  public void onDisable()
  {
	this.getServer().getScheduler().cancelTask(this.pid[1]);
	SaveThread SaveThread = new SaveThread(this);
	int ret = SaveThread.save();
	if(ret < 0)
    {
      if(ret == -2)
        this.info2log("No new save needed, skipping..");
      else
    	this.info2log("Can't save (" + ret + ")");
    }
	else
	  this.info2log(ret + " Events saved");
	this.getServer().getScheduler().cancelTask(this.pid[0]);
	PluginDescriptionFile pdfFile = this.getDescription();
	this.name = pdfFile.getName();
	this.info2log("v" + pdfFile.getVersion() + " disabled");
  }
  
  public void info2log(String text)
  {
    log.info("[" + this.name + "] " + text + ".");
  }
  
  public void addEventStone(Block block, EventStone eventStone)
  {
    this.eventStone.put(block, eventStone);
  }
  public boolean isEventStone(Block block)
  {
    return eventStone.containsKey(block);
  }
  public EventStone getEventStone(Block block)
  {
    if(!isEventStone(block))
      return null;
	return eventStone.get(block);
  }
  public void removeEventStone(Block block)
  {
	if(!isEventStone(block))
	  return;
	
	eventStone.remove(block);
  }
  
  public Collection<EventStone> getValues()
  {
	return eventStone.values();
  }
}
