package com.V10lator.TimeEvent;

import java.util.Collection;
import org.bukkit.block.Block;
import org.bukkit.Material;
import org.bukkit.inventory.ItemStack;
import org.bukkit.entity.Player;
import org.bukkit.event.block.BlockBreakEvent;
import org.bukkit.event.block.BlockListener;
import org.bukkit.event.block.SignChangeEvent;
import org.bukkit.event.block.BlockPhysicsEvent;
import org.bukkit.ChatColor;

public class TimeEventBlockListener extends BlockListener
{
  private TimeEvent plugin;
  public TimeEventBlockListener(final TimeEvent plugin)
  {
	this.plugin = plugin;
  }
  
  public void onBlockPhysics(BlockPhysicsEvent event)
  {
	Block block = event.getBlock();
	Collection<EventStone> stones = plugin.getValues();
	for(EventStone sign: stones)
	{
	  if(block.getWorld().getName().equals(sign.getWorld()) &&
		 block.getX() == sign.getX() &&
		 block.getY() == sign.getY() &&
	     block.getZ() == sign.getZ())
	  {
		event.setCancelled(true);
		break;
	  }
	}
  }
  
  public void onSignChange(SignChangeEvent event)
  {
	Block block = event.getBlock();
	Player player = event.getPlayer();
	String[] lines = event.getLines();
	EventStone stone = new EventStone(block);
	
	if(!lines[1].equalsIgnoreCase("[TimeEvent]"))
	  return;
	if(block.getType() == Material.WALL_SIGN)
	{
	  player.sendMessage(ChatColor.RED + "Wall signs are currently not supported by TimeEvent");
	  block.setType(Material.AIR);
	  player.getInventory().addItem(new ItemStack(Material.SIGN, 1));
	  return;
	}
	if(lines[2].isEmpty())
	{
      player.sendMessage(ChatColor.RED + "A TimeEvent needs a Time!");
	  return;
	}
	Material under = block.getWorld().getBlockAt(block.getX(), block.getY() - 1, block.getZ()).getType();
	if(under == Material.GLASS ||
	   under == Material.ICE ||
	   under == Material.LEAVES ||
	   under == Material.SIGN_POST ||
	   under == Material.WALL_SIGN)
	{
      player.sendMessage(ChatColor.RED + "WARNING: " + ChatColor.YELLOW + "A TimeEvent is a redstone circurit");
      player.sendMessage(ChatColor.YELLOW + "           So it can't be build on " + ChatColor.RED + under.name());
	  block.setType(Material.AIR);
	  player.getInventory().addItem(new ItemStack(Material.SIGN, 1));
	  return;
	}
	
	long foo = plugin.l24t.time2code(lines[2]);
	if(foo < 0)
	{
	  player.sendMessage(ChatColor.RED + lines[2] + "is no valid Time! (lib24time: " + foo + ")");
	  return;
	}

	stone.setWorld(block.getWorld().getName());
    stone.setX(block.getX());
    stone.setY(block.getY());
    stone.setZ(block.getZ());
    stone.setTime(plugin.l24t.code2time(foo));
	this.plugin.addEventStone(block, stone);
	player.sendMessage(ChatColor.YELLOW + "TimeEvent " + ChatColor.GREEN + "created");
  }
  
  public void onBlockBreak(BlockBreakEvent event)
  {
	Block block = event.getBlock();
	Collection<EventStone> stones = plugin.getValues();
	for(EventStone sign: stones)
	{
	  if(block.getWorld().getName().equals(sign.getWorld()) &&
	  block.getX() == sign.getX() &&
	  block.getY() == sign.getY() &&
	  block.getZ() == sign.getZ())
	  {
	    event.setCancelled(true);
	    this.plugin.removeEventStone(block);
	    event.getPlayer().sendMessage(ChatColor.YELLOW + "TimeEvent " + ChatColor.GREEN + "destroyed");
		break;
	  }
	}
  }
}
